SystemOrganization addCategory: #GODWeb!

Object subclass: #WEBElement
	instanceVariableNames: 'html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWeb'!

!WEBElement methodsFor: 'accessing' stamp: 'djp 11/5/2014 19:05'!
html: anHtml
	html := anHtml! !

!WEBElement methodsFor: 'rendering' stamp: 'djp 11/5/2014 19:27'!
render
	"call render of the subclass"
! !

WEBElement subclass: #WEBForm
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWeb'!

!WEBForm methodsFor: 'accessing' stamp: 'djp 11/5/2014 20:18'!
add: anElement
	elements add: anElement! !

!WEBForm methodsFor: 'initialize' stamp: 'djp 11/5/2014 19:30'!
initialize
	elements := OrderedCollection new.! !

!WEBForm methodsFor: 'rendering' stamp: 'djp 11/5/2014 19:31'!
render
	elements do: [ :element | element render ]! !

!WEBForm methodsFor: 'rendering' stamp: 'djp 11/5/2014 20:19'!
render: html
	html form: [
		elements do: [ :element | element render: html ]
	]
! !

!WEBForm methodsFor: 'accessing' stamp: 'djp 11/5/2014 20:59'!
save
	Transcript show: 'Save Information'! !

WEBElement subclass: #WEBFormElement
	instanceVariableNames: 'label value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWeb'!

!WEBFormElement methodsFor: 'accessing' stamp: 'djp 11/5/2014 20:04'!
label
	^label! !

!WEBFormElement methodsFor: 'accessing' stamp: 'djp 11/5/2014 20:04'!
label: aLabel
	label := aLabel! !

!WEBFormElement methodsFor: 'accessing' stamp: 'djp 11/5/2014 20:04'!
value
	^value! !

!WEBFormElement methodsFor: 'accessing' stamp: 'djp 11/5/2014 20:03'!
value: aValue
	value := aValue! !

WEBFormElement subclass: #WEBInputCheckbox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWeb'!

!WEBInputCheckbox methodsFor: 'rendering' stamp: 'djp 11/6/2014 07:32'!
render: html
	html text: label.
	html break.
	html textInput
		callback: [ :aValue | self value: aValue];
		value: value.
	html break.
	html break.! !

WEBFormElement subclass: #WEBInputDate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWeb'!

!WEBInputDate methodsFor: 'rendering' stamp: 'djp 11/6/2014 07:27'!
render: html
	html text: label.
	html break.
	html dateInput
		callback: [ :aValue | self value: aValue];
		value: value.
	html break.
	html break.! !

WEBFormElement subclass: #WEBInputText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWeb'!

!WEBInputText methodsFor: 'rendering' stamp: 'djp 11/5/2014 20:08'!
render: html
	html text: label.
	html break.
	html textInput
		callback: [ :aValue | self value: aValue];
		value: value.
	html break.
	html break.! !

WEBFormElement subclass: #WEBSubmitButton
	instanceVariableNames: 'actionObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWeb'!

!WEBSubmitButton methodsFor: 'accessing' stamp: 'djp 11/6/2014 07:22'!
callback: anObject
	actionObject := anObject! !

!WEBSubmitButton methodsFor: 'rendering' stamp: 'djp 11/6/2014 07:22'!
render: html
	html submitButton 
		callback: [ actionObject save ];
		value: label.
	html break.
		! !

WEBElement subclass: #WEBSpreadSheet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWeb'!

!WEBSpreadSheet methodsFor: 'initialize' stamp: 'djp 11/5/2014 19:02'!
initialize: anGODSpreasheet images: anImageCollection links: anLinkCollection! !

Object subclass: #WEBPage
	instanceVariableNames: 'html title elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWeb'!

!WEBPage methodsFor: 'accessing' stamp: 'djp 11/5/2014 20:17'!
add: anElement
	anElement html: html.
	elements add: anElement.! !

!WEBPage methodsFor: 'accessing' stamp: 'djp 11/5/2014 19:57'!
addElement: anElement
	anElement html: html.
	elements add: anElement.! !

!WEBPage methodsFor: 'accessing' stamp: 'djp 11/5/2014 19:20'!
html: anHtml
	html := anHtml! !

!WEBPage methodsFor: 'initialize' stamp: 'djp 11/5/2014 19:51'!
initialize
	title := 'GOD'.
	elements := OrderedCollection new.
	^self! !

!WEBPage methodsFor: 'rendering' stamp: 'djp 11/5/2014 19:22'!
render: ahtml
	html := ahtml.
	self renderTitle.
	self renderElements.
! !

!WEBPage methodsFor: 'rendering' stamp: 'djp 11/5/2014 20:01'!
renderElements
	elements do: [ :element | element render: html]
! !

!WEBPage methodsFor: 'rendering' stamp: 'djp 11/5/2014 18:49'!
renderTitle
	html heading 
		level: 1; 
		with: title.! !

!WEBPage methodsFor: 'accessing' stamp: 'djp 11/5/2014 18:28'!
title
	^title! !

!WEBPage methodsFor: 'accessing' stamp: 'djp 11/5/2014 18:23'!
title: aTitle
	title := aTitle! !

Object subclass: #WEBPageFetcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODWeb'!

!WEBPageFetcher class methodsFor: 'fetching' stamp: 'has 11/6/2014 17:03'!
fetch: url
	"Returns a MIMEDocument object representing the downloaded file of the given URL. url is a string"

	| response |
	response := [WebClient new httpGet: url]
	
	"Ignore all certificate issues when using HTTPS/SSL"
	on: SqueakSSLCertificateError do: [:ex | ex resume].
	
	^response content unescapePercents.! !
